<template>
  <div id="teacher_class_grading_wrapper" class="bt-container">
    <div
      v-if="!loading">
      <i class="el-icon-loading" style="font-size: 50px;"></i>
    </div>
    <div
      v-if="loading">
      <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
        <el-breadcrumb-item :to="{ path: '/a/teacher/NNclass/'+classId }">{{ class_name }}</el-breadcrumb-item>
        <el-breadcrumb-item>{{ $t('CLASS_MENU.GRADING_MANAGE') }}</el-breadcrumb-item>
      </el-breadcrumb>
      <el-tabs v-model="activeTab">
          <el-tab-pane :label="$t('RESULT.QUES_RESULT')" name="question">
            <div class="one-lecture-wrapper" v-for="lecture in questionList" :key="lecture.lectureId">
              <h3 style="display: inline-block;">{{ lecture.name }}</h3>
              <el-button style="float: right; margin-right: 100px;" @click="resultDownload(lecture.lectureId, 0)">{{ $t('RESULT.RESULT_DOWNLOAD') }}</el-button>
              <el-table :data="lecture.questions">
                <el-table-column
                  prop="no"
                  label="No.">
                </el-table-column>
                <el-table-column
                  prop="type"
                  :label="$t('LECTURE_LIST.TYPE')">
                  <template slot-scope="scope">
                    <span v-if="scope.row.type === '객관'">
                      {{ $t('QUESTION.MULTI_ANS') }}
                    </span>
                    <span v-else-if="scope.row.type === '단답'">
                      {{ $t('QUESTION.SHORT_ANS') }}
                    </span>
                    <span v-else-if="scope.row.type === '서술'">
                      {{ $t('QUESTION.ESSAY') }}
                    </span>
                    <span v-else-if="scope.row.type === '멀티미디어'">
                      {{ $t('QUESTION.MULTIMEDIA') }}
                    </span>
                    <span v-else-if="scope.row.type === '연결형'">
                      {{ $t('QUESTION.CONNECTION') }}
                    </span>
                    <span v-else-if="scope.row.type === 'SW'">
                      {{ 'SW' }}
                    </span>
                  </template>
                </el-table-column>
                <el-table-column
                  prop="name"
                  :label="$t('RESULT.LEC_ITEM_NAME')">
                </el-table-column>
                <el-table-column
                  :label="$t('RESULT.STD_GRADED_NUM')">
                  <template slot-scope="scope">
                    {{ scope.row.numberOfScored }} / {{scope.row.numberOfStudent}}
                  </template>
                </el-table-column>
                <el-table-column
                  :label="$t('RESULT.AVRG_SCORE')">
                  <template slot-scope="scope">
                    <!-- {{ scope.row.avgScore.toFixed(2) }} / {{scope.row.score}} -->
                    {{ scope.row.avgScore.toFixed(2) }}
                  </template>
                </el-table-column>
                <el-table-column
                  label=""
                  width="200">
                  <template slot-scope="scope">
                    <el-button size="small" @click="onClickResult('QUESTION', scope.row.itemId)">{{ $t('RESULT.VIEW_DETAIL') }}</el-button>
                  </template>
                </el-table-column>
              </el-table>
            </div>
          </el-tab-pane>

          <el-tab-pane :label="$t('RESULT.SURV_RESULT')" name="survey">
            <div class="one-lecture-wrapper" v-for="lecture in surveyList" :key="lecture.lectureId">
              <h3 style="display: inline-block;">{{ lecture.name }}</h3>
              <el-button style="float: right; margin-right: 100px;" @click="resultDownload(lecture.lectureId, 1)">{{ $t('RESULT.RESULT_DOWNLOAD') }}</el-button>
              <el-table :data="lecture.surveys">
                <el-table-column
                  prop="no"
                  label="No.">
                </el-table-column>
                <el-table-column
                  prop="type"
                  :label="$t('LECTURE_LIST.TYPE')">
                  <template slot-scope="scope">
                    <span v-if="scope.row.type === '객관'">
                      {{ $t('SURVEY.MULTI_CHOI') }}
                    </span>
                    <span v-else-if="scope.row.type === '서술'">
                      {{ $t('SURVEY.ESSAY') }}
                    </span>
                  </template>
                </el-table-column>
                <el-table-column
                  prop="name"
                  :label="$t('RESULT.LEC_ITEM_NAME')">
                </el-table-column>
                <el-table-column
                  prop="numberOfStudent"
                  :label="$t('RESULT.SRVY_PRTCP_NUM')">
                </el-table-column>
                <el-table-column
                  label="">
                  <template slot-scope="scope">
                    <el-button size="small" @click="onClickResult('SURVEY', scope.row.itemId)">{{ $t('STUDENT_MENU.VIEW_RESULTS') }}</el-button>
                  </template>
                </el-table-column>
              </el-table>
            </div>
          </el-tab-pane>
      </el-tabs>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  #teacher_class_grading_wrapper {
    .one-lecture-wrapper {
      margin-bottom: 40px;
    }
    .align-right {
      text-align: right;
    }
  }
</style>


<script>
import downloadService from '../../services/downloadService';
import classService from '../../services/classService';
import lectureItemService from '../../services/lectureItemService';
import utils from '../../utils';

export default {
  name: 'TeacherClassGrading',
  data() {
    return {
      loading: false,
      activeTab: 'question',
      class_name: '',
      questionList: '',
      surveyList: '',
      practiceList: '',
      codingList: '',
    };
  },
  async created() {
    const vm = this;

    // 데이터 요청 - 문항, 설문
    const res = await classService.getClassTotalResult({
      id: vm.classId,
    });
    // 데이터 요청 - 실습 : TODO
    const res2 = await lectureItemService.getWholeSimilarityScores({
      classId: vm.classId,
    });

    // 데이터 가공
    vm.class_name = res.data.result.name;

    // 데이터 가공 - 문항
    const questions = [];
    for (let i = 0; i < res.data.result.lectures.length; i += 1) {
      const lec = res.data.result.lectures[i];
      questions.push({
        lectureId: lec.lecture_id,
        name: lec.name,
        questions: [],
      });
      let n = 1;
      for (let j = 0; j < lec.lecture_items.length; j += 1) {
        const item = lec.lecture_items[j];
        if (item.type === 0) {
          let type;
          if (item.questions[0] !== undefined && item.questions[0].type !== undefined) {
            type = utils.convertQuestionType(item.questions[0].type);
          }
          let numberOfScored = 0;
          let avgScore = 0;
          for (let k = 0; k < item.questions[0].student_answer_logs.length; k += 1) {
            if (item.questions[0].student_answer_logs[k].score !== null) {
              numberOfScored += 1;
              avgScore += item.questions[0].student_answer_logs[k].score;
            }
          }
          if (numberOfScored !== 0) avgScore /= numberOfScored;
          questions[i].questions.push({
            no: n,
            type,
            name: item.name,
            numberOfStudent: item.questions[0].student_answer_logs.length,
            numberOfScored,
            answers: item.questions[0].student_answer_logs,
            score: item.questions[0].score,
            avgScore,
            itemId: item.lecture_item_id,
            questionId: item.questions[0].question_id,
            question: item.questions[0].question,
            keywords: item.questions[0].question_keywords,
            choice: item.questions[0].choice,
            // 복수정답에서 답이 하나만 전송되는 문제 190423
            answer: item.questions[0].answer,
            inputDescription: item.questions[0].input_description,
            outputDescription: item.questions[0].output_description,
            sampleInput: item.questions[0].sample_input,
            sampleOutput: item.questions[0].sample_output,
            timeLimit: item.questions[0].time_limit,
            memoryLimit: item.questions[0].memory_limit,
            acceptLanguage: item.questions[0].accept_language,
            answer_media_type: item.questions[0].answer_media_type,
            multi_choice_media_type: item.questions[0].multi_choice_media_type,
          });
          n += 1;
        }
      }
    }
    vm.questionList = questions;

    // 데이터 가공 - 설문
    const surveys = [];
    for (let i = 0; i < res.data.result.lectures.length; i += 1) {
      const lec = res.data.result.lectures[i];
      surveys.push({
        lectureId: lec.lecture_id,
        name: lec.name,
        surveys: [],
      });
      let n = 1;
      for (let j = 0; j < lec.lecture_items.length; j += 1) {
        const item = lec.lecture_items[j];
        if (item.type === 1) {
          surveys[i].surveys.push({
            no: n,
            type: item.surveys[0].type === 0 ? '객관' : '서술',
            name: item.name,
            numberOfStudent: item.surveys[0].student_surveys.length,
            itemId: item.lecture_item_id,
            comment: item.surveys[0].comment,
            answers: item.surveys[0].student_surveys,
            choice: item.surveys[0].choice,
          });
          n += 1;
        }
      }
    }
    vm.surveyList = surveys;

    // TODO: 데이터 가공 - 실습 : 실습과 코딩과제는 바뀔수도
    // 데이터 가공 - 문항
    const practices = [];
    for (let i = 0; i < res.data.result.lectures.length; i += 1) {
      const lec = res.data.result.lectures[i];
      practices.push({
        lectureId: lec.lecture_id,
        name: lec.name,
        practices: [],
      });
    }
    vm.practiceList = practices;

    // TODO: 데이터 가공 - 코딩 과제  : 실습과 코딩과제는 바뀔수도
    const codings = [];
    for (let i = 0; i < res.data.result.lectures.length; i += 1) {
      const lec = res.data.result.lectures[i];
      codings.push({
        lectureId: lec.lecture_id,
        name: lec.name,
        codings: [],
      });
    }
    vm.codingList = codings;

    // 로딩 아이콘 없애고 화면 표시
    vm.loading = true;
  },
  methods: {
    onClickResult(type, itemId) {
      const vm = this;
      if (type === 'QUESTION') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/question/${itemId}`);
      } else if (type === 'SURVEY') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/survey/${itemId}`);
      } else if (type === 'PRACTICE') {
        vm.$router.push(`/a/teacher/class/${vm.classId}/grading/practice/${itemId}`);
      } else if (type === 'CODING') {
        // need fixing
      }
    },
    dataToExcel(name, content) {
      const BLOB = new Blob(['\ufeff' + content], {
        type: 'text/csv;charset=EUC-KR;'
      });

      if (navigator.appVersion.toString().indexOf('.NET') > 0) {
        window.navigator.msSaveBlob(BLOB, name);
      } else {
        const ENCODED_URL = URL.createObjectURL(BLOB);
        const LINK = document.createElement('a');
        LINK.setAttribute('href', ENCODED_URL);
        LINK.setAttribute('download', name);
        LINK.click();
      }
    },
    async resultDownload(lectureId, type) {
      const vm = this;

      const { name, content } = (await downloadService.studentResultDownload(lectureId, type)).data;
      vm.dataToExcel(name, content);
    }
  },
  computed: {
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
};
</script>
